/* 
 * File:   gs_math.h
 * Author: eis_os (cim bytetransfer.de)
 *
 * Created on 14.07.2011
 * 
 * last update: 09.08.2011
 */
#ifndef GS_MATH_H
#define	GS_MATH_H

#include "gs.h"

#ifdef	__cplusplus
extern "C" {
#endif


struct gs_vec vec_add(gs_vec l, gs_vec r);
struct gs_vec vec_sub(gs_vec l, gs_vec r);
struct gs_vec vec_crossproduct(gs_vec l, gs_vec r);
float vec_dotproduct(gs_vec l, gs_vec r);

struct gs_quat quat_multiply(gs_quat l, gs_quat r);
struct gs_quat quat_invert(gs_quat q);
struct gs_quat vec_to_quad(gs_vec vec);
struct gs_vec quad_to_vec(gs_quat quat);
struct gs_vec quat_multiply_vec(gs_quat quat, gs_vec vec);
struct gs_vec quat_to_euler(gs_quat quat);
struct gs_quat euler_to_quat(gs_vec vec);
    
extern const float DEGTORAD;
extern const float RADTODEG;
 
#ifdef	__cplusplus
}
#endif

#endif	/* GS_MATH_H */

